#include <stdlib.h>
#include "extstring.h"

void es_addsymbol(tExtstring* string, char symbol) {

	if (string == NULL)
		return;

	tExtstring* ptr = string;

	while (ptr->next != NULL) {
		ptr = ptr->next;
	};

	ptr->next = malloc(sizeof(tExtstring));
	ptr->next->symbol = symbol;
	ptr->next->next = NULL;

	return;

}

int es_size(tExtstring* string) {

	int size = 0;

	tExtstring* ptr = string;

	for (; ptr != NULL; size++) {
		ptr = ptr->next;
	}

	return size;
}

void es_free(tExtstring* string) {

	if (string->next == NULL) {

		free(string);

		return;

	}

	tExtstring* ptr = string;
	tExtstring* nextptr = ptr->next;

	while (ptr->next != NULL) {

		nextptr = ptr->next;
		free(ptr);
		ptr = nextptr;

	}

	free(ptr);

}

char* es_tostring(tExtstring* string) {

	tExtstring* ptr = string;

	int size = es_size(string) + 1;

	char* cstring = malloc(size);

	for (int i = 0; i != size; i++) {

		if (ptr != NULL) {
			cstring[i] = ptr->symbol;
			ptr = ptr->next;
		}

		else
			cstring[i] = 0;
	}

	return cstring;

}
