#ifndef SYNTAX_H
#define SYNTAX_H

#include <stdbool.h>

enum SyntaxElementType {

	NEWTREE,
	TREE,
	TOKEN,
	STRING,
	NONE

};

typedef union {

	struct SyntaxElement* syntax;
	char* string;
	void* none;

} tSyntaxContent;

typedef struct SyntaxElement {

	enum SyntaxElementType type;
	tSyntaxContent content;
	struct SyntaxElement* next;
	struct SyntaxElement* top;

} tSyntaxElement;


void se_free(tSyntaxElement*);

bool se_istraversable(tSyntaxElement*);

tSyntaxElement* se_create(void);

tSyntaxElement* se_init(void);

tSyntaxElement* se_bottom(tSyntaxElement*);

tSyntaxElement* se_next(tSyntaxElement*);

tSyntaxElement* se_clone(tSyntaxElement*, tSyntaxElement*);

tSyntaxElement* se_clone_no_next(tSyntaxElement*, tSyntaxElement*);

tSyntaxElement* se_find_last(tSyntaxElement*);

#endif
